src/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'SiteController@index')->name('index');

Auth::routes(['verify' => true, 'register' => false]);
Route::get('epost-bekreftet', 'Auth\VerificationController@complete');

Route::get('konto', 'UserController@show')->name('user.show');
Route::post('konto', 'UserController@update')->name('user.update');

Route::get('kontrollpanel', 'DashboardController@index')->name('dashboard.index');

Route::get('admin/kontrollpanel', 'AdminController@index')->name('admin.index');
Route::post('admin/steder/sok', 'AdminController@search_place')->name('admin.places.search');
Route::post('admin/steder/søk', 'AdminController@search_place');
Route::get('admin/steder/{place}/endre', 'AdminController@edit_place')->name('admin.places.edit');
Route::patch('admin/steder/{place}/oppdater', 'AdminController@update_place')->name('admin.places.update');
Route::get('admin/brukere/opprett', 'AdminController@create_user')->name('admin.users.create');
Route::post('admin/brukere/lagre', 'AdminController@store_user')->name('admin.users.store');

Route::prefix('steder')->group(function () {
    Route::get('/', 'PlaceController@index')->name('places.index');
    Route::get('opprett', 'PlaceController@create')->name('places.create');
    Route::post('lagre', 'PlaceController@store')->name('places.store');
    Route::get('{place_slug}', 'PlaceController@show')->name('places.show');
    Route::get('{place}/endre', 'PlaceController@edit')->name('places.edit');
    Route::patch('{place}/oppdater', 'PlaceController@update')->name('places.update');
    Route::get('{place}/fjern', 'PlaceController@delete')->name('places.delete');
    Route::delete('{place}/slett', 'PlaceController@destroy')->name('places.destroy');

    Route::get('{place}/apningstider', 'PlaceController@opening_hours');
});

src/app/Place.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

use Carbon\Carbon;

use App\User;
use App\PlaceUser;
use App\PlaceOpenHour;
use App\Traits\UsesUuid;

class Place extends Model
{
    use UsesUuid;

    public static function findBySlug(String $slug)
    {
        return self::where('slug', $slug)->first();
    }

    public function users()
    {
        return $this->belongsToMany('App\Place')->withPivot('user_id', 'place_id');
    }

    public function address()
    {
        return $this->belongsTo('App\Address');
    }

    public function place_type()
    {
        return $this->belongsTo('App\PlaceType');
    }

    public function userHasAccess(User $user)
    {
        $place_user = PlaceUser::where([
            'user_id' => $user->id,
            'place_id' => $this->id
        ])->first();

        if ($user->hasRole('admin')) {
            return true;
        }

        return ($place_user !== null);
    }

    public function getDescriptionAttribute($value)
    {
        return htmlspecialchars(strip_tags($value));
    }

    public function getDescriptionFormattedAttribute()
    {
        return nl2br( $this->description );
    }

    public function getDescriptionShortAttribute()
    {
        $description = substr($this->description, 0, 128);
        if (strlen($description) < 128) {
            return $description;
        }

        return $description . '...';
    }

    public function getSpecialHoursTextAttribute($value)
    {
        return htmlspecialchars(strip_tags($value));
    }

    public function getSpecialHoursTextFormattedAttribute()
    {
        return nl2br( $this->special_hours_text );
    }

    public function getOpeningHoursRegularAttribute()
    {
        return PlaceOpenHour::where('place_id', $this->id)->whereIn('weekday', [1, 2, 3, 4, 5, 6, 7])->get();
    }

    public function getOpeningHoursAttribute()
    {
        return $this->openingHours();
    }

    public function openingHours(bool $limit = true)
    {
        // Get all regular and special hours
        $open_hours_regular = PlaceOpenHour::where('place_id', $this->id)->
                                             whereIn('weekday', [1, 2, 3, 4, 5, 6, 7])->
                                             orderBy('weekday')->
                                             get();

        if ($limit) {
            $open_hours_special =  PlaceOpenHour::where('place_id', $this->id)->
                                                  whereDate('special_hours_date', '>=', Carbon::now())->
                                                  whereDate('special_hours_date', '<', Carbon::now()->addMonths(2))->
                                                  orderBy('special_hours_date')->
                                                  get();
        } else {
            $open_hours_special =  PlaceOpenHour::where('place_id', $this->id)->
                                                  whereDate('special_hours_date', '>=', Carbon::now())->
                                                  orderBy('special_hours_date')->
                                                  get();
        }

        $open_hours = new \stdClass;
        $open_hours->open_now = false;
        $open_hours->special_hours_text = $this->special_hours_text;
        $open_hours->regular = [];
        $open_hours->special = [];

        for ($i=1; $i <= 7 ; $i++) {
            $regular = new PlaceOpenHour;
            $regular->weekday = $i;
            $regular->time_from = null;
            $regular->time_to = null;
            $regular->special_hours_date = null;

            $open_hours->regular[$i] = $regular;
        }

        // Add regular hours to array, indexed by weekday
        foreach ($open_hours_regular as $regular) {
            $open_hours->regular[$regular->weekday] = $regular;
        }

        $monday    = Carbon::now()->startOfWeek();
        $sunday    = Carbon::now()->endOfWeek();

        // Add special hours to array
        foreach ($open_hours_special as $special) {
            $special_date = new Carbon($special->special_hours_date);
            $special->weekday = $special_date->dayOfWeekIso;

            array_push($open_hours->special, $special);

            if ($special_date->isBetween($monday, $sunday, true)) {
                $regular = $open_hours->regular[$special->weekday];

                $special->normal_time_from = $regular->time_from;
                $special->normal_time_to = $regular->time_to;

                $open_hours->regular[$special->weekday] = $special;
            }
        }

        // Figure out if the place is open right now
        $day_of_week = Carbon::now()->dayOfWeekIso;
        if (isset($open_hours->regular[$day_of_week])) {
            $todays_opening_hours = $open_hours->regular[$day_of_week];

            if ($todays_opening_hours->time_from !== null) {
                $open_now = Carbon::now()->isBetween($todays_opening_hours->time_from_carbon, $todays_opening_hours->time_to_carbon);
                $open_hours->open_now = $open_now;
            }
        }

        return $open_hours;
    }
}

src/app/PlaceType.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class PlaceType extends Model
{
    public $timestamps = false;
}

src/app/Http/Controllers/PlaceController.php
<?php

namespace App\Http\Controllers;

use Auth;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Validator;

use App\Country;
use App\Address;
use App\Place;
use App\PlaceType;
use App\PlaceRole;
use App\PlaceUser;
use App\PlaceOpenHour;
use Carbon\Carbon;

class PlaceController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth')->except('show', 'opening_hours');
        $this->middleware('verified')->except('show', 'opening_hours');
        $this->middleware('cors')->only('opening_hours');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $place_types = PlaceType::all();
        $weekdays = PlaceOpenHour::getWeekdays();
        $time_now = Carbon::now()->format('H:i');
        $available_hours = PlaceOpenHour::getAvailableHours();

        return view('places.create', compact('place_types', 'weekdays', 'time_now', 'available_hours'));
    }

    protected function place_validator(array $data)
    {
        return Validator::make($data, [
            'name' => ['required', 'string', 'max:255'],
            'slug' => ['required', 'string', 'max:255'],
            'description' => ['nullable', 'string', 'max:1024'],
            'address_id' => ['required', Rule::in(Address::pluck('id')->toArray())],
            'place_type_id' => ['required', Rule::in(PlaceType::pluck('id')->toArray())],
            'website' => ['nullable', 'URL'],
            'phone' => ['nullable', 'string'],
            'email' => ['nullable', 'email'],
            'founded_at' => ['nullable', 'date'],
            'special_hours_text' => ['nullable', 'string', 'max:512']
        ]);
    }

    protected function address_validator(array $data)
    {
        return Validator::make($data, [
            'street_name_number' => ['required', 'string', 'max:255'],
            'postal_code' => ['required', 'string', 'max:255'],
            'postal_city' => ['required', 'string', 'max:255'],
            'province' => ['required', 'string', 'max:255']
        ]);
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $user = $request->user();
        $session = $request->session();

        // Validate address inputs
        $this->address_validator($request->all())->validate();

        // Check if address already exist
        $address = Address::findByInfo($request->street_name_number, $request->postal_code, $request->postal_city, $request->province);

        // If address doesn't exist, create it
        if ($address === null) {
            $address = new Address;
            $address->street_name_number = $request->street_name_number;
            $address->postal_code = $request->postal_code;
            $address->postal_city = $request->postal_city;
            $address->province = $request->province;
            $address->country_id = Country::first()->id;
            $address->save();
        }

        // Add address_id and slug to the request
        $request->merge(['address_id' => $address->id]);
        $request->merge(['slug' => str_slug($request->name)]);

        // Slugs are supposed to be unique. Is there already a place with this slug?
        // If there is, prepend some random string to the slug
        $place = Place::findBySlug($request->slug);
        if ($place !== null) {
            $random_string = bin2hex(random_bytes(8));
            $request->merge(['slug' => str_slug($request->name . '-' . $random_string)]);
        }

        // Validate the place inputs
        $this->place_validator($request->all())->validate();

        // Create the place
        $place = new Place;
        $place->place_type_id = $request->place_type_id;
        $place->name = $request->name;
        $place->slug = $request->slug;
        $place->description = strip_tags($request->description);
        $place->address_id = $request->address_id;
        $place->place_type_id = $request->place_type_id;
        $place->website = $request->website;
        $place->phone = $request->phone;
        $place->email = $request->email;
        $place->founded_at = $request->founded_at;
        $place->save();

        // Find the place owner role
        $place_role = PlaceRole::where([
            'slug' => 'owner',
            'place_type_id' => $place->place_type_id
        ])->first();

        // Give the place and role to the user
        $place_user = new PlaceUser;
        $place_user->user_id = $user->id;
        $place_user->place_id = $place->id;
        $place_user->place_role_id = $place_role->id;
        $place_user->save();

        // Set opening hours
        $weekdays = PlaceOpenHour::getWeekdays();

        foreach ($weekdays as $weekday_name) {
            $weekday_name_slug = str_slug($weekday_name);
            $input_name_open_closed = 'open_hours_open_closed_' . $weekday_name_slug;
            $input_name_open_from = 'open_hours_from_'  . $weekday_name_slug;
            $input_name_open_to = 'open_hours_to_'  . $weekday_name_slug;

            $day_is_open = $request->has($input_name_open_closed) && $request->{$input_name_open_closed} == 'on';

            if ($day_is_open && $request->has($input_name_open_from) && $request->has($input_name_open_to)) {

                // Validate the opening and closing times
                $place_open_hours_validated = PlaceOpenHour::validateTimes($request->{$input_name_open_from}, $request->{$input_name_open_to});
                if ($place_open_hours_validated === true) {
                    $place_open_hour = new PlaceOpenHour;
                    $place_open_hour->place_id = $place->id;
                    $place_open_hour->weekday = PlaceOpenHour::getWeekdayNumber($weekday_name);
                    $place_open_hour->time_from = $request->{$input_name_open_from};
                    $place_open_hour->time_to = $request->{$input_name_open_to};
                    $place_open_hour->save();
                } else {
                    $session->flash('error', __($place_open_hours_validated, ['weekday' => lcfirst($weekday_name)]));
                    return redirect()->back()->withInput();
                }
            }
        }

        $session->flash('success', 'Stedet ble opprettet');
        return redirect()->route('dashboard.index');
    }

    /**
     * Display the specified resource.
     *
     * @param  String  $place_slug
     * @return \Illuminate\Http\Response
     */
    public function show(String $place_slug)
    {
        $place = Place::findBySlug($place_slug);

        if ($place == null) {
            abort(404, __('Place not found'));
        }

        $weekdays = PlaceOpenHour::getWeekdays();

        return view('places.show', compact('place', 'weekdays'));
    }

    public function opening_hours(Place $place)
    {
        return response()->json($place->openingHours(false));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Place  $place
     * @return \Illuminate\Http\Response
     */
    public function edit(Request $request, Place $place)
    {
        if (!$place->userHasAccess($request->user())) {
            $request->session()->flash('error', 'Du har ikke tilgang til å redigere dette stedet.');
            return redirect()->route('dashboard.index');
        }

        $place_types = PlaceType::all();
        $weekdays = PlaceOpenHour::getWeekdays();
        $time_now = Carbon::now()->format('H:i');
        $available_hours = PlaceOpenHour::getAvailableHours();

        return view('places.edit', compact('place', 'place_types', 'weekdays', 'time_now', 'available_hours'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Place  $place
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Place $place)
    {
        if (!$place->userHasAccess($request->user())) {
            $request->session()->flash('error', 'Du har ikke tilgang til å redigere dette stedet.');
            return redirect()->route('dashboard.index');
        }

        $user = $request->user();
        $session = $request->session();

        // Validate address inputs
        $this->address_validator($request->all())->validate();

        // Check if address already exist
        $address = Address::findByInfo($request->street_name_number, $request->postal_code, $request->postal_city, $request->province);

        // If address doesn't exist, create it
        if ($address === null) {
            $address = new Address;
            $address->street_name_number = $request->street_name_number;
            $address->postal_code = $request->postal_code;
            $address->postal_city = $request->postal_city;
            $address->province = $request->province;
            $address->country_id = Country::first()->id;
            $address->save();
        }

        // Add address_id and slug to the request
        $request->merge(['address_id' => $address->id]);
        $request->merge(['slug' => str_slug($request->name)]);

        // Validate the place inputs
        $this->place_validator($request->all())->validate();

        // Create the place
        $place->place_type_id = $request->place_type_id;
        $place->name = $request->name;
        $place->description = strip_tags($request->description);
        $place->address_id = $request->address_id;

src/resources/views/places/create.blade.php
@extends('partials.master')

@section('content')
<h1>{{ __('Add a new place') }}</h1>

<form class="form-place" action="{{ route('places.store') }}" method="post">
    @csrf

    @include('places.form-fields')

    <div class="form-group form-group-actions">
        <button type="submit">{{ __('Save') }}</button>
    </div>
</form>
@endsection

src/resources/views/places/delete.blade.php
@extends('partials.master')

@section('content')
<h1>{{ __('Delete place') }}</h1>

<form class="form-place" action="{{ route('places.destroy', $place) }}" method="post">
    @csrf
    @method('delete')

    <fieldset>
        <legend>{{ __('Are you sure?') }}</legend>
        <p>{{ __('Do you really want to delete :place?', ['place' => $place->name]) }}</p>

        <div class="form-group">
            <a href="{{ URL::previous() }}">{{ __('No, cancel') }}</a>
        </div>

        <div class="form-group">
            <button type="submit">{{ __('Yes, delete') }}</button>
        </div>
    </fieldset>
</form>
@endsection

src/resources/views/places/edit.blade.php
@extends('partials.master')

@section('content')
<h1>{{ __('Edit place') }}</h1>

<form class="form-place" action="{{ route('places.update', $place) }}" method="post">
    @csrf
    @method('patch')

    @include('places.form-fields')

    <div class="form-group form-group-actions">
        <button type="submit">{{ __('Update') }}</button>
    </div>
</form>
@endsection

src/resources/views/places/form-fields.blade.php
@php
    // Random enough for our needs.
    // We just want to avoid collision in case the fields
    // are included multiple times on a single page
    $random = 'form-place-' . bin2hex(random_bytes(4));
@endphp
<fieldset>
    <legend>{{ __('About place') }}</legend>
    <div class="form-group">
        <label for="{{ $random }}-name">{{ __('Name') }}</label>
        <input id="{{ $random }}-name" type="text" name="name" value="{{ old('name', isset($place->name) ? $place->name : null) }}" required autocomplete="organization">
    </div>
    <div class="form-group">
        <label for="{{ $random }}-description">{{ __('Description') }}</label>
        <textarea id="{{ $random }}-description" name="description">{{ old('description', isset($place->description) ? $place->description : null) }}</textarea>
    </div>
    <div class="form-group">
        <label for="{{ $random }}-place_type">{{ __('Place type') }}</label>
        <select id="{{ $random }}-place_type" name="place_type_id" required>
            @php
                $old_value = old('place_type', isset($place->place_type_id) ? $place->place_type_id : null);
            @endphp
            @if ($old_value == null)
                <option value="" hidden selected disabled>{{ __('Pick one') }}</option>
            @endif
            @foreach ($place_types as $place_type)
                @if ($old_value == $place_type->id)
                    <option value="{{ $place_type->id }}" selected>{{ $place_type->name }}</option>
                @else
                    <option value="{{ $place_type->id }}">{{ $place_type->name }}</option>
                @endif
            @endforeach
        </select>
    </div>
    <div class="form-group">
        <label for="{{ $random }}-founded_at">{{ __('Founded at') }}</label>
        <input id="{{ $random }}-founded_at" type="text" name="founded_at" value="{{ old('founded_at', isset($place->founded_at) ? $place->founded_at : null) }}">
    </div>
</fieldset>
<fieldset>
    <legend>{{ __('Address') }}</legend>
    <div class="form-group">
        <label for="{{ $random }}-street_name_number">{{ __('Street name and number') }}</label>
        <input id="{{ $random }}-street_name_number" type="text" name="street_name_number" value="{{ old('street_name_number', isset($place->address->street_name_number) ? $place->address->street_name_number : null) }}" required autocomplete="street-address">
    </div>
    <div class="form-group">
        <label for="{{ $random }}-postal_code">{{ __('Postal code') }}</label>
        <input id="{{ $random }}-postal_code" type="text" name="postal_code" value="{{ old('postal_code', isset($place->address->postal_code) ? $place->address->postal_code : null) }}" required autocomplete="postal-code">
    </div>
    <div class="form-group">
        <label for="{{ $random }}-postal_city">{{ __('City') }}</label>
        <input id="{{ $random }}-postal_city" type="text" name="postal_city" value="{{ old('postal_city', isset($place->address->postal_city) ? $place->address->postal_city : null) }}" required autocomplete="address-level2">
    </div>
    <div class="form-group">
        <label for="{{ $random }}-province">{{ __('Province') }}</label>
        <input id="{{ $random }}-province" type="text" name="province" value="{{ old('province', isset($place->address->province) ? $place->address->province : null) }}" required autocomplete="address-level1">
    </div>
</fieldset>
<fieldset>
    <legend>{{ __('Links and contact info') }}</legend>
    <div class="form-group">
        <label for="{{ $random }}-website">{{ __('Website') }}</label>
        <input id="{{ $random }}-website" type="url" name="website" value="{{ old('website', isset($place->website) ? $place->website : null) }}" autocomplete="url">
    </div>
    <div class="form-group">
        <label for="{{ $random }}-phone">{{ __('Phone') }}</label>
        <input id="{{ $random }}-phone" type="tel" name="phone" value="{{ old('phone', isset($place->phone) ? $place->phone : null) }}" autocomplete="tel-local">
    </div>
    <div class="form-group">
        <label for="{{ $random }}-email">{{ __('Email') }}</label>
        <input id="{{ $random }}-email" type="email" name="email" value="{{ old('email', isset($place->email) ? $place->email : null) }}" autocomplete="email">
    </div>
</fieldset>
<fieldset>
    <datalist id="available-hours">
        @foreach ($available_hours as $available_hour)
            <option value="{{$available_hour}}"/>
        @endforeach
    </datalist>
    <legend>{{ __('Opening hours') }}</legend>
    <p>{{ __('Fill out hours on the 24-hour format (hh:mm).') . ' ' . __('For example:') . ' ' . $time_now }}</p>
    @php
        $i = 0;
    @endphp
    @foreach ($weekdays as $weekday)
        @php
            $i++;
            $weekday_slug = str_slug($weekday);
            $open_from = null;
            $open_to = null;
            $day_is_open = false;

            if (isset($place->opening_hours_regular)) {
                $open_hours = $place->opening_hours_regular->where('weekday', $i)->first();

                if ($open_hours != null) {
                    $open_from = $open_hours->time_from;
                    $open_to = $open_hours->time_to;

                    if ($open_from != null || $open_to != null) {
                        $day_is_open = true;
                    }
                }
            }
        @endphp
        <fieldset class="form-group form-group-opening-hours">
            <legend>{{ $weekday }}</legend>
            <input
                id="{{ $random }}-{{ $weekday_slug }}-open_closed"
                type="checkbox"
                class="input-toggle"
                name="open_hours_open_closed_{{ $weekday_slug }}"
                {{ old('open_hours_open_closed_' . $weekday_slug, $day_is_open) ? 'checked' : null }}
            >
            <label class="input-toggle-label" for="{{ $random }}-{{ $weekday_slug }}-open_closed">
                <span class="input-toggle-off">{{ __('Closed') }}</span>
                <span class="input-toggle-on">{{ __('Open') }}</span>
            </label>
            <div class="input-toggle-target">
                <div class="input-toggle-on">
                    <input
                        type="text"
                        placeholder="{{ __('Opens at') }}"
                        aria-label="{{ __(':weekday opens at', ['weekday' => $weekday]) }}"
                        name="open_hours_from_{{ $weekday_slug }}"
                        value="{{ old('open_hours_from_' . $weekday_slug, $open_from) }}"
                        pattern="([01]?[0-9]|2[0-3]):[0-5][0-9]"
                        oninvalid="this.setCustomValidity('{{ __('Fill out hours on the 24-hour format (hh:mm).') }}')"
                        oninput="this.setCustomValidity('')"
                        list="available-hours"
                        autocomplete="off"
                    ><span>—</span><input
                        type="text"
                        placeholder="{{ __('Closes at') }}"
                        aria-label="{{ __(':weekday closes at', ['weekday' => $weekday]) }}"
                        name="open_hours_to_{{ $weekday_slug }}"
                        value="{{ old('open_hours_to_' . $weekday_slug, $open_to) }}"
                        pattern="([01]?[0-9]|2[0-3]):[0-5][0-9]"
                        oninvalid="this.setCustomValidity('{{ __('Fill out hours on the 24-hour format (hh:mm).') }}')"
                        oninput="this.setCustomValidity('')"
                        list="available-hours"
                        autocomplete="off"
                    >
                </div>
            </div>
        </fieldset>
    @endforeach
</fieldset>

@if (isset($place))
    <fieldset>
        <legend>{{ __('Special hours') }}</legend>
        <p>
            {{ __('Got any holidays or vacations coming up? You can add the opening hours for those days here.') }}
        </p>
        <div class="form-group">
            <label for="{{ $random }}-special_hours_text">{{ __('Reason for special hours') }}</label>
            <textarea id="{{ $random }}-special_hours_text" name="special_hours_text">{{ old('special_hours_text', isset($place->special_hours_text) ? $place->special_hours_text : null) }}</textarea>
        </div>
        <p>
            <button class="form-place-special-hours-add" type="button">{{ __('Add new special hour') }}</button>
        </p>

        <input type="hidden" class="form-place-id" value="{{ $place->id }}">
        <div class="form-place-special-hours-wrapper"></div>
        <button class="form-place-special-hours-add" type="button">{{ __('Add new special hour') }}</button>
    </fieldset>
@endif

src/resources/views/places/show.blade.php
@extends('partials.master')

@section('content')
<article itemscope itemtype="http://schema.org/LocalBusiness">
    <h1 itemprop="name">{{ $place->name }}</h1>
    <ul>
        @if ($place->website)
            <li class="url" itemprop="sameAs"><a href="{{ $place->website }}" target="_blank" ref="noopener nofollow noreferrer">{{ $place->website }}</a></li>
        @endif
        @if ($place->phone)
            <li class="phone" itemprop="telephone"><a href="tel:{{ $place->phone }}">{{ $place->phone }}</a></li>
        @endif
        @if ($place->email)
            <li class="email" itemprop="email"><a href="mailto:{{ $place->email }}">{{ $place->email }}</a></li>
        @endif
        <li class="address" itemprop="address" itemscope itemtype="http://schema.org/PostalAddress">
            <a href="{{ url('https://www.google.com/maps/search/' .  $place->address->street_name_number . ' ' . $place->address->postal_code . ' ' . $place->address->postal_city) }}"
                target="_blank"
                ref="noopener nofollow noreferrer"
            >
                <span itemprop="streetAddress">{{ $place->address->street_name_number }}</span>,
                <span itemprop="postalCode">{{ $place->address->postal_code }}</span>
                <span itemprop="addressLocality">{{ $place->address->postal_city }}</span>
            </a>
        </li>
    </ul>
    <p class="about" itemprop="description">{!! ($place->description_formatted) !!}</p>

    @if (count($place->opening_hours_regular) > 0)
        <h2>{{ __('Opening hours') }}</h2>
        @php
            $i = 0;
        @endphp
        @foreach ($weekdays as $weekday)
            <p><strong>{{ $weekday }}:</strong> {{ $place->opening_hours->regular[++$i]->timeFromTo() }}</p>
            <meta itemprop="openingHours" content="{{ $weekday }} {{ $place->opening_hours->regular[$i]->timeFromTo(false) }}"/>
        @endforeach
    @endif

    @if (count($place->opening_hours->special) > 0)
        <hr>
        <h3>{{ __('Special hours') }}</h3>
        <p class="about">{!! ($place->special_hours_text) !!}</p>
        @foreach ($place->opening_hours->special as $special_hour)
            <p><strong>{{ $weekdays[$special_hour->weekday] }} {{ $special_hour->date }}:</strong> {{ $special_hour->timeFromTo(false) }}</p>
            <meta itemprop="openingHours" content="{{ $special_hour->date }} {{ $special_hour->timeFromTo(false) }}"/>
        @endforeach
    @endif
</article>
@endsection